//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrLimeGreen
#property indicator_color4  clrPaleVioletRed
#property indicator_color5  clrPaleVioletRed
#property indicator_color6  clrSilver
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT; // Time frame
extern int                SZOPeriod          = 14;             // Sentiment zone short period
extern int                SZOLongPeriod      = 30;             // Sentiment zone long period
extern ENUM_APPLIED_PRICE SZOPrice           = PRICE_CLOSE;    // Price
extern int                PriceFiltering     = 14;             // Price filtering period
extern ENUM_MA_METHOD     PriceFilteringMode = MODE_SMA;       // Price filtering mode
extern double             SZOPercent         = 95;             // Level up percent
extern int                AveragePeriod      = 14;             // Level down percent
extern ENUM_MA_METHOD     AverageType        = MODE_EMA;       // Average tpe for sentiment zone signal line
extern bool               AlertsOn           = false;          // Turn alerts on
extern bool               AlertsOnCurrent    = true;           // Alerts on current
extern bool               AlertsMessage      = true;           // Alerts message
extern bool               AlertsSound        = false;          // Alerts sound
extern bool               AlertsEmail        = false;          // Alerts email
extern bool               Interpolate        = true;           // Interpolate

double upz[],dnz[],szo[],szoda[],szodb[],avg[],prices[],trend[];
string indicatorFileName;
bool   returnBars;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,SZOLongPeriod,SZOPrice,PriceFiltering,PriceFilteringMode,SZOPercent,AveragePeriod,AverageType,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,_buff,_y)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,upz);
   SetIndexBuffer(1,dnz);
   SetIndexBuffer(2,szo);
   SetIndexBuffer(3,szoda);
   SetIndexBuffer(4,szodb);
   SetIndexBuffer(5,avg);
   SetIndexBuffer(6,prices);
   SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" Sentiment zone oscillator ("+(string)SZOPeriod+","+(string)SZOLongPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { upz[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != _Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               if (trend[limit]== 1) CleanPoint(limit,szoda,szodb);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  int x = (i<Bars-1) ? iBarShift(NULL,TimeFrame,Time[i+1]) : y;
                     upz[i]   = _mtfCall(0,y);
                     dnz[i]   = _mtfCall(1,y);
                     szo[i]   = _mtfCall(2,y);
                     avg[i]   = _mtfCall(5,y);
                     trend[i] = _mtfCall(7,y);
                     szoda[i] = EMPTY_VALUE;
                     szodb[i] = EMPTY_VALUE;
                  
                     //
                     //
                     //
                     //
                     //
                  
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                        #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                        int n,k; datetime ctime = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<Bars && Time[i+n] >= ctime; n++) continue;	
                           for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                           {
                              _interpolate(upz);
                              _interpolate(dnz);
                              _interpolate(szo);
                              _interpolate(avg);
                           }                              
               }
               for(int i=limit; i>=0; i--) if (trend[i]==-1) PlotPoint(i,szoda,szodb,szo);
               return(0);
            }
  

   //
   //
   //
   //
   //

   if (trend[limit]== 1) CleanPoint(limit,szoda,szodb);
   for(int i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,PriceFiltering,0,PriceFilteringMode,SZOPrice,i);
      double useValue = (i<Bars-1) ? (prices[i]>prices[i+1]) ? 1 : (prices[i]<prices[i+1]) ? -1 : 0 : 0;
      
      //
      //
      //
      //
      //
         
       szo[i] =  100.0*iTema(useValue,SZOPeriod,i)/SZOPeriod;
            double hi = szo[ArrayMaximum(szo,SZOLongPeriod,i)];
            double lo = szo[ArrayMinimum(szo,SZOLongPeriod,i)];
            double rn = hi-lo;
         upz[i] = lo+rn*SZOPercent/100.0;
         dnz[i] = hi-rn*SZOPercent/100.0;
   }       
   for(int i=limit; i>=0; i--)
   {
      avg[i]   = iMAOnArray(szo,0,AveragePeriod,0,AverageType,i);
      trend[i] = (szo[i]>avg[i]) ? 1 : (szo[i]<avg[i]) ? -1 : (i<Bars-1) ? trend[i+1] : 0;
      szoda[i] = EMPTY_VALUE;
      szodb[i] = EMPTY_VALUE;
               if (trend[i]==-1) PlotPoint(i,szoda,szodb,szo);
   }               
   if (AlertsOn)
   {
      int whichBar = 1; if (AlertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(" sentiment zone oscillator state changed to up");
         if (trend[whichBar] ==-1) doAlert(" sentiment zone oscillator state changed to down");
      }         
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTema[][3];
#define _tema1 0
#define _tema2 1
#define _tema3 2

double iTema(double price, double period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workTema,0)!= Bars) ArrayResize(workTema,Bars); instanceNo*=3; r=Bars-r-1;

   //
   //
   //
   //
   //
      
   workTema[r][_tema1+instanceNo] = price;
   workTema[r][_tema2+instanceNo] = price;
   workTema[r][_tema3+instanceNo] = price;
   if (r>0 && period>1)
   {
      double alpha = 2.0 / (1.0+period);
          workTema[r][_tema1+instanceNo] = workTema[r-1][_tema1+instanceNo]+alpha*(price                         -workTema[r-1][_tema1+instanceNo]);
          workTema[r][_tema2+instanceNo] = workTema[r-1][_tema2+instanceNo]+alpha*(workTema[r][_tema1+instanceNo]-workTema[r-1][_tema2+instanceNo]);
          workTema[r][_tema3+instanceNo] = workTema[r-1][_tema3+instanceNo]+alpha*(workTema[r][_tema2+instanceNo]-workTema[r-1][_tema3+instanceNo]); }
   return(workTema[r][_tema3+instanceNo]+3.0*(workTema[r][_tema1+instanceNo]-workTema[r][_tema2+instanceNo]));
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (AlertsMessage) Alert(message);
             if (AlertsEmail)   SendMail(_Symbol+" sentiment zone oscillator",message);
             if (AlertsSound)   PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}